package com.xinelu.manage.mapper.textmessage;

import com.xinelu.manage.domain.textmessage.TextMessage;
import com.xinelu.manage.domain.textmessagesuittask.TextMessageSuitTask;
import com.xinelu.manage.dto.textmessage.TextMessageDTO;
import com.xinelu.manage.dto.textmessage.TextMessageTaskDTO;
import com.xinelu.manage.vo.textmessage.TextMessageVO;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 短信模板信息Mapper接口
 *
 * @author xinelu
 * @date 2024-02-28
 */
public interface TextMessageMapper {
    /**
     * 查询短信模板信息
     *
     * @param id 短信模板信息主键
     * @return 短信模板信息
     */
    public TextMessage selectTextMessageById(Long id);

    /**
     * 查询短信模板信息列表
     *
     * @param textMessageDTO 短信模板信息
     * @return 短信模板信息集合
     */
    public List<TextMessageVO> selectTextMessageList(TextMessageDTO textMessageDTO);

    /**
     * 新增短信模板信息
     *
     * @param textMessage 短信模板信息
     * @return 结果
     */
    public int insertTextMessage(TextMessage textMessage);

    /**
     * 修改短信模板信息
     *
     * @param textMessage 短信模板信息
     * @return 结果
     */
    public int updateTextMessage(TextMessage textMessage);

    /**
     * 删除短信模板信息
     *
     * @param id 短信模板信息主键
     * @return 结果
     */
    public int deleteTextMessageById(Long id);

    /**
     * 批量删除短信模板信息
     *
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteTextMessageByIds(Long[] ids);

    /**
     * 根据id查询短信模板信息
     */
    TextMessageVO selectTextMessageInfoById(Long id);

    /**
     * 检查短信模板信息是否存在
     */
    int countByTextMessageTaskDTO(TextMessageTaskDTO textMessageTaskDTO);

    /**
     * 批量插入短信模板适用任务类型
     */
    int insertTextMessageSuitTasks(List<TextMessageSuitTask> tasks);

	List<TextMessageSuitTask> selectSuitTaskList(TextMessageSuitTask textMessageSuitTask);

    /**
     * 批量删除短信模板适用任务类型
     */
    int deleteTextMessageSuitTasks(Long[] ids);

    /**
     * 修改短信模板适用任务类型
     */
    int updateTextMessageSuitTask(@Param("task") TextMessageSuitTask task);

    /**
     * 根据id删除之前的适用任务类型
     */
    void deleteTextMessageSuitTask(Long id);

    /**
     * 检查除当前记录之外是否存在同名的短信模板名称
     */
    int countByTextMessageNameExcludingId(@Param("id") Long id, @Param("departmentId") Long departmentId, @Param("textMessageName") String textMessageName);

    /**
     * 查询短信模板信息列表
     *
     * @return 短信模板信息集合
     */
    List<TextMessageVO> selectTextMessages();
}
